package primi;

import java.util.BitSet;

public class PrimeSet5 {
	private BitSet primeset;

	public PrimeSet5(long n) {
		this.primeset = new BitSet((int) (8 * n / 30.));
	}

	public void set(long fromIndex, long toIndex) {
		for (long i = fromIndex; i < toIndex; i++)
			this.set(i);
	}

	public long nextSetBit(long fromIndex) {
		long i = fromIndex;
		while (!this.get(i++)) {}
		return i - 1;
	}

	public int cardinality() {
		return primeset.cardinality() + 3;
	}

	public void set(long i) {
		if (i % 2 == 0 || i % 3 == 0 || i % 5 == 0) return;
		primeset.set((int) (8 * i / 30.));
	}

	public void clear(long i) {
		if (i % 2 == 0 || i % 3 == 0 || i % 5 == 0) return;
		primeset.clear((int) (8 * i / 30.));
	}

	public boolean get(long i) {
		if (i % 2 == 0 || i % 3 == 0 || i % 5 == 0) return false;
		return primeset.get((int) (8 * i / 30.));
	}
}